#ifndef ROWEDLIST_H
#define ROWEDLIST_H

#include <QColor>
#include <QFont>
#include <QFontMetrics>
#include <QWidget>
#include <QStringList>
#include <QPair>
/*
  ????? ?????????? ???????? ? QScrollArea ? ??????? scrollArea->setWidgetResizable(true);
  ? ????????? ??????? ??? ??? ????????, ?????? ?????????
*/
class RowedList : public QWidget
{
    Q_OBJECT
public:
    RowedList(QWidget *parent = 0);
    QFont font() { return curFont; } //????? ???????? ? ???????
    //?????? ????, ?? ????????? ????? ?????? ????????
    int rowHeight() const { return curRowHeight; } 
    //?????? ??????? ??????????, ?? ????????? ?????? ?????? ???????? ?????????
    int headerWidth() const { return curHeaderWidth; }
    //?????? ??????, ?? ????????? ????? ??????
    int cellWidth() const { return curCellWidth; }
    QSize sizeHint() const;
    
public slots:
	 void clear();
    void setFont(const QFont &newFont);
    void setRowHeight(int newRowHeight);
    void setHeaderWidth(int newHeaderWidth);
    void setCellWidth(int newCellWidth);
    //?????? ????????? ?????? ?????? ????? ???? "header 1|abcdef" << "header 2|abcdef"...
    //??? header 1, header 2... - ????????? (????? ???? ???????)
    // "|" - ??????, ??????????? ????????? ? ???????
    //abcdef... - ????? ???????
    void setItems(const QStringList &); 

signals:
    void characterSelected(const QString & s); //?????? ???????? ????????? ??????
protected:
    void mousePressEvent(QMouseEvent *event);
    void paintEvent(QPaintEvent *event);
    void resizeEvent(QResizeEvent *event);
private:
    QFont curFont;
    QFont curHeaderFont;
    int curCount;
    int curRowHeight;
    int curCellWidth;
    int curHeaderWidth;
    QStringList headers;
    QStringList items;
    QList<int> headersPos;
    int numberOfCols;
    int numberOfRows; 
    QPair<int,int> lastKey;
};
#endif

